////////////////////////////////////////////////////////////////////
//
//  Tutorial uso di MySql con driver ODBC della actual technologies
//
//  Created by Francesco Germinara 
// 
//  Freeware (c) 2005 SofTech di F.Germinara - www.germinara.it. 
//
//  For information please contact me at info@germinara.it 
////////////////////////////////////////////////////////////////////
//  History:
//
//  Description:
//
////////////////////////////////////////////////////////////////////

#import "panelRegaliController.h"

#import "NSString+FGString.h" //Expand NSString class using Categories
#import "FGBseData.h"         //manage Data field

@implementation panelRegaliController


- (void) dealloc {
	[dsRegali release];
	[super dealloc];
}


-(void) awakeFromNib{
  dsRegali=[[FGODBCResultSet alloc] init:theApp SetIdentifier:@"REGALI" tableView:elencoRegali];
  
  [self setCtrlStat:TRUE]; //enable/disable control in user interface
  
  [elencoRegali setTarget:self];
  [elencoRegali setDoubleAction:@selector(loadSelectedData)]; //Double click
 
  
}

- (void)windowDidBecomeKey:(NSNotification *)aNotification{
 static int bOnlyOnce=0;
 if(!bOnlyOnce){
  [self startUseDataSource];
  bOnlyOnce=1;
 }
}

-(void) startUseDataSource{
 [elencoRegali setDataSource:nil];
   //Execute the query for dataset result 
 [dsRegali FillArray:theApp->pTabRegali SqlFilter:@"order by ID_REGALO" ProgressInd:nil]; 
 //Set datasource to tableview
 [elencoRegali setDataSource:dsRegali];
 }

- (IBAction)btnBarraAzionePremuto:(id)sender
{
 //Chiudo la finestra
 int nOperationToDo=0;
 nOperationToDo=[sender selectedSegment]; //Get the Button That is selected on the segment
 id aPanel=[sender window];
 
  if(nOperationToDo == 0){ //REGISTRA was pressed Insert/Modify the record
   [self updateRecord];
  
   [self startUseDataSource];    //refresh datasource 
   
   [self setCtrlStat:TRUE];
   [self clearFelds];
  }
  
 if(nOperationToDo == 1){ //CANCELLA was pressed Delete the record
	NSString *strInfo;
	strInfo=[NSString stringWithFormat:@"Do you want delete %@.  Are you sure ?",[[idRegalo stringValue]TrimRight]];
	int rc=NSRunAlertPanel(@"Warning!",strInfo,@"YES",@"NO",nil);
	if(rc==NSOKButton){	
     [self deleteRecord];
  
    [self startUseDataSource];    //refresh datasource 
	
	[self setCtrlStat:TRUE];
	[self clearFelds];
   }
  }

 if(nOperationToDo == 2){ //ELIMINA TUTTI was pressed Delete all records
  NSString *strInfo;
  strInfo=[NSString stringWithString:@"Do you want remove all records. Are you sure ?"];
  int rc=NSRunAlertPanel(@"Warning!",strInfo,@"YES",@"NO",nil);
  if(rc==NSOKButton){	
   [self deleteAllRecords];
  
   [self startUseDataSource];    //refresh datasource 
   
   [self setCtrlStat:TRUE];
   [self clearFelds];
   }
  }
  
  if(nOperationToDo == 3){ //STAMPA was pressed Print all records
   [elencoRegali print:self];
  }
 

 if(nOperationToDo == 4){      //ESCI was pressed close sheet  
  [self setCtrlStat:TRUE];
  [aPanel  orderOut:nil];      //Close the panel
  [NSApp endSheet:aPanel ];    //End the sheet loop
 }
 
}

- (IBAction)btnModificaPremuto:(id)sender
{

//1: Check if key field is valid
NSString *aString=[[idRegalo stringValue] TrimRight]; //Eliminate right blanks

if([aString isEqualToString:@""]){
 NSRunAlertPanel(@"ERROR",@"You must specify a valid id for the gift!",@"OK",nil,nil);
 return;
}

if([aString length] >25){
 NSRunAlertPanel(@"ERROR",@"Lenght must not exceed 25 character!",@"OK",nil,nil);
 return;
}

//2: Check if record already present
NSMutableString *strQuery;
strQuery=[NSMutableString stringWithFormat:@"WHERE ID_REGALO='%@' ",aString]; //Build the query 

if([theApp->pTabRegali LoadDati:strQuery] == TRUE){
 NSLog(@"Found: %@ in table REGALI",aString);
 //Update info in user interface
 [descrizione setStringValue:[[theApp->pTabRegali FieldInfo:@"DESCR"] GetValue]];
 [etada setStringValue:[[theApp->pTabRegali FieldInfo:@"ETA_DA"] GetValue]];
 [etaa setStringValue:[[theApp->pTabRegali FieldInfo:@"ETA_A"] GetValue]];
 [idealeper setStringValue:[[theApp->pTabRegali FieldInfo:@"IDEALE_PER"] GetValue]];
 [costo setStringValue:[[theApp->pTabRegali FieldInfo:@"COSTO"] GetValue]];
 [flgSingle setState:[[[theApp->pTabRegali FieldInfo:@"ADATTO_SINGLE"] GetValue] intValue]];
}else{
 NSLog(@"Not Found: %@ in table REGALI",aString);
 //New record, clear fields
 [self clearFelds];
}

[self setCtrlStat:FALSE];

}

//Update Record
-(void)updateRecord{
NSMutableString *strQuery;
NSString *aString=[[idRegalo stringValue] TrimRight]; //Eliminate right blanks

strQuery=[NSMutableString stringWithFormat:@"WHERE ID_REGALO='%@' ",aString]; //Build the query 
BOOL sts=[theApp->pTabRegali LoadDati:strQuery]; //New Insert or Update ?

//Assign new data value for the record	
[[theApp->pTabRegali FieldInfo:@"ID_REGALO"] SetValue:aString];	
[[theApp->pTabRegali FieldInfo:@"DESCR"] SetValue:[descrizione stringValue]];	
[[theApp->pTabRegali FieldInfo:@"ETA_DA"] SetValue:[etada stringValue]]; //Int
[[theApp->pTabRegali FieldInfo:@"ETA_A"] SetValue:[etaa stringValue]];
[[theApp->pTabRegali FieldInfo:@"IDEALE_PER"] SetValue:[idealeper stringValue]];
if([flgSingle state]==TRUE)
 [[theApp->pTabRegali FieldInfo:@"ADATTO_SINGLE"] SetValue:@"1"];
else
 [[theApp->pTabRegali FieldInfo:@"ADATTO_SINGLE"] SetValue:@"0"];
[[theApp->pTabRegali FieldInfo:@"COSTO"] SetValue:[costo stringValue]]; //real
 	
 //If not exist make a INSERT else a UPDATE	
 if(sts==FALSE)
  [theApp->pTabRegali Insert];
 else
  [theApp->pTabRegali Update:strQuery];

}

//Delete Record
-(void)deleteRecord{
NSMutableString *strQuery;
NSString *aString=[[idRegalo stringValue] TrimRight]; //Eliminate right blanks

strQuery=[NSMutableString stringWithFormat:@"WHERE ID_REGALO='%@' ",aString]; //Build the query 
[theApp->pTabRegali Delete:strQuery]; 
}

//Delete all records
-(void)deleteAllRecords{
 [theApp->pTabRegali Delete:@""]; 
}

//enable/disable control in user interface
-(void)setCtrlStat:(BOOL) bSts{

 [idRegalo setEnabled:bSts];
 [costo setEnabled:!bSts];
 [descrizione setEnabled:!bSts];
 [etada setEnabled:!bSts];
 [etaa setEnabled:!bSts];
 [flgSingle setEnabled:!bSts];
 [idealeper setEnabled:!bSts];
 
 [pulsantiAzione setEnabled:!bSts forSegment:0]; //Enable/Disable REGISTRA
 [pulsantiAzione setEnabled:!bSts forSegment:1]; //Enable/Disable CANCELLA
 [btnModifica setEnabled:bSts];
}

//Double click action
-(void)loadSelectedData{
 int nSelectedRow=[elencoRegali clickedRow];
 FGODBCRecord *tmpRecord=[dsRegali GetSingleRow:nSelectedRow];

 //Update info in user interface
 [idRegalo setStringValue:[[tmpRecord FieldInfo:@"ID_REGALO"] GetValue]];
 [descrizione setStringValue:[[tmpRecord FieldInfo:@"DESCR"] GetValue]];
 [etada setStringValue:[[tmpRecord FieldInfo:@"ETA_DA"] GetValue]];
 [etaa setStringValue:[[tmpRecord FieldInfo:@"ETA_A"] GetValue]];
 [idealeper setStringValue:[[tmpRecord FieldInfo:@"IDEALE_PER"] GetValue]];
 [costo setStringValue:[[tmpRecord FieldInfo:@"COSTO"] GetValue]];
 [flgSingle setState:[[[tmpRecord FieldInfo:@"ADATTO_SINGLE"] GetValue] intValue]];

 [self setCtrlStat:FALSE];
}

//Clear user input fields data
-(void)clearFelds{
 [descrizione setStringValue:@""];
 [etada setStringValue:@""];
 [etaa setStringValue:@""];
 [idealeper setStringValue:@""];
 [costo setStringValue:@""];
 [flgSingle setState:FALSE]; 
}


@end
